#include <windows.h>       /* required for all Windows applications */

	int dll_proc_start=0;
	int dll_thread_start=0;

	CRITICAL_SECTION	Bmap_Critical;



BOOL WINAPI DllMain(
    HINSTANCE hinstDLL,  // handle to DLL module
    DWORD fdwReason,     // reason for calling function
    LPVOID lpReserved )  // reserved
{
    // Perform actions based on the reason for calling.
    switch( fdwReason ) 
    { 
        case DLL_PROCESS_ATTACH:
         // Initialize once for each new process.
         // Return FALSE to fail DLL load.
			dll_proc_start=1;		

			InitializeCriticalSection(&Bmap_Critical);
            break;

        case DLL_THREAD_ATTACH:
         // Do thread-specific initialization.
			dll_thread_start=1;
            break;

        case DLL_THREAD_DETACH:
         // Do thread-specific cleanup.
			dll_thread_start=0;
            break;

        case DLL_PROCESS_DETACH:
         // Perform any necessary cleanup.

			dll_proc_start=0;
			DeleteCriticalSection(&Bmap_Critical);
            break;
    }
    return TRUE;  // Successful DLL_PROCESS_ATTACH.
}
