#include <memory.h>
#include <stdio.h>

#include "memfile.h"

static	int		rpos=0;
static	int		rbfmax;
static	char    *rbf;

static	int		opos=0;
static	char    *obf;


void MemInOpen (unsigned char *bf,int siz)
{
	rpos	=	0;
	rbf		=	bf;
	rbfmax	=	siz;
}

int	MemRead (unsigned char *bf ,int tln,int dln,void *dmy)
{
	int  tsize;
	if (rpos >=rbfmax ) {
		return 0;
	}

	tsize = tln * dln;
	if (tsize + rpos >= rbfmax ) {
		tsize  = rbfmax - rpos;
	}
	memcpy (bf,rbf+rpos,tsize);
	rpos += tsize;

	return tsize;
}

unsigned char	MemGet (void)
{
	unsigned char  rt;

	if (rpos >=rbfmax ) {
		return EOF;
	}
	rt =  rbf[rpos++];
	return  rt;
}

void MemInClose (void)
{
}


void MemOtOpen (unsigned char *bf)
{
	opos	=	0;
	obf		=	bf;
}

int	MemWrite (unsigned char *bf ,int tln,int dln,void *dmy)
{
	int  tsize;

	tsize =  tln * dln;
	memcpy (obf+opos,bf,tsize);
	opos += tsize;	
	return  tsize;
}

int	MemPut (int dt)
{
	obf[opos++] = dt;
	return  dt;
}

int  MemOtClose (void)
{
	return opos;
}
