#include <windows.h>       /* required for all Windows applications */
#include <vfw.h>
#include <commctrl.h>  

#define USE_BITMAXSIZE	(640*480*4+100000)		// 921,600 Byte + 100,000(\j
#define USE_JPGMAXSIZE	(640*480*4+100000)		// BMP WL & JPG BUFF

	HDRAWDIB	hdrawdibCvb;
	PBYTE		pcvbbmp;
	PBYTE		pcvbbwk;
	PBYTE		pcvbjpg;

	int dll_proc_start=0;
	int dll_thread_start=0;
static	INITCOMMONCONTROLSEX	initcom;
extern	int APIENTRY	BitDispInit (void);
extern	int APIENTRY	BitDispEnd (void);


BOOL WINAPI DllMain(
    HINSTANCE hinstDLL,  // handle to DLL module
    DWORD fdwReason,     // reason for calling function
    LPVOID lpReserved )  // reserved
{
    // Perform actions based on the reason for calling.
    switch( fdwReason ) 
    { 
        case DLL_PROCESS_ATTACH:
         // Initialize once for each new process.
         // Return FALSE to fail DLL load.
			dll_proc_start=1;		
			initcom.dwSize = sizeof(INITCOMMONCONTROLSEX);
			initcom.dwICC  = ICC_INTERNET_CLASSES | ICC_TAB_CLASSES ;
			InitCommonControlsEx (&initcom); 
			hdrawdibCvb = DrawDibOpen();
			pcvbbmp = VirtualAlloc(NULL,USE_BITMAXSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
			pcvbbwk = VirtualAlloc(NULL,USE_BITMAXSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
			pcvbjpg = VirtualAlloc(NULL,USE_JPGMAXSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
			BitDispInit();
          break;

        case DLL_THREAD_ATTACH:
         // Do thread-specific initialization.
			dll_thread_start=1;

            break;

        case DLL_THREAD_DETACH:
         // Do thread-specific cleanup.
			dll_thread_start=0;

            break;

        case DLL_PROCESS_DETACH:
         // Perform any necessary cleanup.
			dll_proc_start=0;
			VirtualFree( pcvbbmp,0,MEM_RELEASE );
			VirtualFree( pcvbbwk,0,MEM_RELEASE );
			VirtualFree( pcvbjpg,0,MEM_RELEASE );
			BitDispEnd ();
			DrawDibClose (hdrawdibCvb);
            break;
    }
    return TRUE;  // Successful DLL_PROCESS_ATTACH.
}
